(* arrays.t - status: not-ready, expanded              *)
(* originally from Lamports 9/91 TLA+ text, adapted to *)
(* 2/92 and to Dortmund-Syntax, Mester, 10.7.92        *)

CONSTANT MODULE Arrays 
EXPORT  OPAQUE Image, ReplaceValue ;
(* EXPORTS  _[_:=_]  Image *)

CONSTANTS
  (* original, adapted to _ _ style:                       *)
  (* _a : [Any -> Any]_ [ _e_ := _f_ ] : [Any -> Any]  ==  *) 
  (*     ARRAY x :in: DOMAIN a : IF x = e THEN f ELSE a[x] *) 
  (* obsolete, we do have a notation for it in 2/92, as an  *)
  (* example it has been converted anyway *)

  (* Image _a : [Any -> Any]_ : Any  ==  UNION( x :in: DOMAIN( a : {a[x]} ) ) *)
  (* both converted to functional notation *)

   ReplaceValue( a : SET [Any -> Any]; e; f ) : SET [Any -> Any]  == 
       [ FCN x :in: DOMAIN( a ) :mapsto: IF x = e
                                         THEN f
                                         ELSE a[x]
       ] ;

  Image(a : SET [Any -> Any]) : Any  == { a[x] | x :in: DOMAIN(a) };

	(* urspruenglich:			  *)
	(* UNION( x :in: DOMAIN( a : {a[x]} ) ) ; *)

END 
