TEMPORAL MODULE Service

  IMPORT ElevatorDefs;

  PARAMETERS Light     : SET [ Floor -> OnOff ] STATE FCN;
             Location  : Floor                  STATE FCN;
             Direction : Directions             STATE FCN;

  PREDICATES
    Init == /\ :A: f :in: Floor :: Light[f] = "off"
            /\ Location = "olaf1"
    ;

  ACTIONS
    PressButton (f:Floor) ==
      /\ Light[f] = "off"
      /\ (Light[f])' = "on"
      /\ UNCHANGED( Location, Direction )
      /\ :A: v :in: Floor :: v # f => (Light[v]) = (Light[v])'
    ;

END Service
